Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -3918,96 +3828,98 @@
 !--  Level 2 - initialization via building type read from file
      IF ( building_type_f%from_file )  THEN
-        DO  m = 1, surf_usm_h%ns
-           i = surf_usm_h%i(m)
-           j = surf_usm_h%j(m)
-!
-!--        For the moment, limit building type to 6 (to overcome errors in input file).
-           st = building_type_f%var(j,i)
-           IF ( st /= building_type_f%fill )  THEN
-
-!
-!--           In order to distinguish between ground floor level and above-ground-floor level
-!--           surfaces, set input indices.
-
-              ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl,               &
-                                        surf_usm_h%ground_level(m) )
-              ind_lai_r        = MERGE( ind_lai_r_gfl, ind_lai_r_agfl, surf_usm_h%ground_level(m) )
-              ind_z0           = MERGE( ind_z0_gfl, ind_z0_agfl, surf_usm_h%ground_level(m) )
-              ind_z0qh         = MERGE( ind_z0qh_gfl, ind_z0qh_agfl, surf_usm_h%ground_level(m) )
-!
-!--           Store building type and its name on each surface element
-              surf_usm_h%building_type(m)      = st
-              surf_usm_h%building_type_name(m) = building_type_name(st)
-!
-!--           Initialize relatvie wall- (0), green- (1) and window (2) fractions
-              surf_usm_h%frac(m,ind_veg_wall)  = building_pars(ind_wall_frac_r,st)
-              surf_usm_h%frac(m,ind_pav_green) = building_pars(ind_green_frac_r,st)
-              surf_usm_h%frac(m,ind_wat_win)   = building_pars(ind_win_frac_r,st)
-              surf_usm_h%lai(m)                = building_pars(ind_lai_r,st)
-
-              surf_usm_h%rho_c_wall(nzb_wall,m)   = building_pars(ind_hc1_wall_r,st)
-              surf_usm_h%rho_c_wall(nzb_wall+1,m) = building_pars(ind_hc1_wall_r,st)
-              surf_usm_h%rho_c_wall(nzb_wall+2,m) = building_pars(ind_hc2_wall_r,st)
-              surf_usm_h%rho_c_wall(nzb_wall+3,m) = building_pars(ind_hc3_wall_r,st)
-              surf_usm_h%lambda_h(nzb_wall,m)     = building_pars(ind_tc1_wall_r,st)
-              surf_usm_h%lambda_h(nzb_wall+1,m)   = building_pars(ind_tc1_wall_r,st)
-              surf_usm_h%lambda_h(nzb_wall+2,m)   = building_pars(ind_tc2_wall_r,st)
-              surf_usm_h%lambda_h(nzb_wall+3,m)   = building_pars(ind_tc3_wall_r,st)
-
-              surf_usm_h%rho_c_green(nzb_wall,m)      = rho_c_soil !building_pars(ind_hc1_wall_r,st)
-              surf_usm_h%rho_c_green(nzb_wall+1,m)    = rho_c_soil !building_pars(ind_hc1_wall_r,st)
-              surf_usm_h%rho_c_green(nzb_wall+2,m)    = rho_c_soil !building_pars(ind_hc2_wall_r,st)
-              surf_usm_h%rho_c_green(nzb_wall+3,m)    = rho_c_soil !building_pars(ind_hc3_wall_r,st)
-              surf_usm_h%lambda_h_green(nzb_wall,m)   = lambda_h_green_sm !building_pars(ind_tc1_wall_r,st)
-              surf_usm_h%lambda_h_green(nzb_wall+1,m) = lambda_h_green_sm !building_pars(ind_tc1_wall_r,st)
-              surf_usm_h%lambda_h_green(nzb_wall+2,m) = lambda_h_green_sm !building_pars(ind_tc2_wall_r,st)
-              surf_usm_h%lambda_h_green(nzb_wall+3,m) = lambda_h_green_sm !building_pars(ind_tc3_wall_r,st)
-
-              surf_usm_h%rho_c_window(nzb_wall,m)      = building_pars(ind_hc1_win_r,st)
-              surf_usm_h%rho_c_window(nzb_wall+1,m)    = building_pars(ind_hc1_win_r,st)
-              surf_usm_h%rho_c_window(nzb_wall+2,m)    = building_pars(ind_hc2_win_r,st)
-              surf_usm_h%rho_c_window(nzb_wall+3,m)    = building_pars(ind_hc3_win_r,st)
-              surf_usm_h%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1_win_r,st)
-              surf_usm_h%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1_win_r,st)
-              surf_usm_h%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2_win_r,st)
-              surf_usm_h%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3_win_r,st)
-
-              surf_usm_h%target_temp_summer(m)  = building_pars(ind_indoor_target_temp_summer,st)
-              surf_usm_h%target_temp_winter(m)  = building_pars(ind_indoor_target_temp_winter,st)
-!
-!--           Emissivity of wall-, green- and window fraction
-              surf_usm_h%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall_r,st)
-              surf_usm_h%emissivity(m,ind_pav_green) = building_pars(ind_emis_green_r,st)
-              surf_usm_h%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win_r,st)
-
-              surf_usm_h%transmissivity(m)      = building_pars(ind_trans_r,st)
-
-              surf_usm_h%z0(m)                  = building_pars(ind_z0,st)
-              surf_usm_h%z0h(m)                 = building_pars(ind_z0qh,st)
-              surf_usm_h%z0q(m)                 = building_pars(ind_z0qh,st)
-!
-!--           Albedo type for wall fraction, green fraction, window fraction
-              surf_usm_h%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall_r,st) )
-              surf_usm_h%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green_r,st) )
-              surf_usm_h%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win_r,st) )
-
-              surf_usm_h%zw(nzb_wall,m)   = building_pars(ind_thick_1_wall_r,st)
-              surf_usm_h%zw(nzb_wall+1,m) = building_pars(ind_thick_2_wall_r,st)
-              surf_usm_h%zw(nzb_wall+2,m) = building_pars(ind_thick_3_wall_r,st)
-              surf_usm_h%zw(nzb_wall+3,m) = building_pars(ind_thick_4_wall_r,st)
-
-              surf_usm_h%zw_green(nzb_wall,m)   = building_pars(ind_thick_1_wall_r,st)
-              surf_usm_h%zw_green(nzb_wall+1,m) = building_pars(ind_thick_2_wall_r,st)
-              surf_usm_h%zw_green(nzb_wall+2,m) = building_pars(ind_thick_3_wall_r,st)
-              surf_usm_h%zw_green(nzb_wall+3,m) = building_pars(ind_thick_4_wall_r,st)
-
-              surf_usm_h%zw_window(nzb_wall,m)   = building_pars(ind_thick_1_win_r,st)
-              surf_usm_h%zw_window(nzb_wall+1,m) = building_pars(ind_thick_2_win_r,st)
-              surf_usm_h%zw_window(nzb_wall+2,m) = building_pars(ind_thick_3_win_r,st)
-              surf_usm_h%zw_window(nzb_wall+3,m) = building_pars(ind_thick_4_win_r,st)
-
-              surf_usm_h%green_type_roof(m) = building_pars(ind_green_type_roof,st)
-
-           ENDIF
+        DO  l = 0, 1
+           DO  m = 1, surf_usm_h(l)%ns
+              i = surf_usm_h(l)%i(m)
+              j = surf_usm_h(l)%j(m)
+!
+!--           For the moment, limit building type to 6 (to overcome errors in input file).
+              st = building_type_f%var(j,i)
+              IF ( st /= building_type_f%fill )  THEN
+
+!
+!--              In order to distinguish between ground floor level and above-ground-floor level
+!--              surfaces, set input indices.
+
+                 ind_green_frac_r = MERGE( ind_green_frac_r_gfl, ind_green_frac_r_agfl,               &
+                                           surf_usm_h(l)%ground_level(m) )
+                 ind_lai_r        = MERGE( ind_lai_r_gfl, ind_lai_r_agfl, surf_usm_h(l)%ground_level(m) )
+                 ind_z0           = MERGE( ind_z0_gfl, ind_z0_agfl, surf_usm_h(l)%ground_level(m) )
+                 ind_z0qh         = MERGE( ind_z0qh_gfl, ind_z0qh_agfl, surf_usm_h(l)%ground_level(m) )
+!
+!--              Store building type and its name on each surface element
+                 surf_usm_h(l)%building_type(m)      = st
+                 surf_usm_h(l)%building_type_name(m) = building_type_name(st)
+!
+!--              Initialize relatvie wall- (0), green- (1) and window (2) fractions
+                 surf_usm_h(l)%frac(m,ind_veg_wall)  = building_pars(ind_wall_frac_r,st)
+                 surf_usm_h(l)%frac(m,ind_pav_green) = building_pars(ind_green_frac_r,st)
+                 surf_usm_h(l)%frac(m,ind_wat_win)   = building_pars(ind_win_frac_r,st)
+                 surf_usm_h(l)%lai(m)                = building_pars(ind_lai_r,st)
+
+                 surf_usm_h(l)%rho_c_wall(nzb_wall,m)   = building_pars(ind_hc1_wall_r,st)
+                 surf_usm_h(l)%rho_c_wall(nzb_wall+1,m) = building_pars(ind_hc1_wall_r,st)
+                 surf_usm_h(l)%rho_c_wall(nzb_wall+2,m) = building_pars(ind_hc2_wall_r,st)
+                 surf_usm_h(l)%rho_c_wall(nzb_wall+3,m) = building_pars(ind_hc3_wall_r,st)
+                 surf_usm_h(l)%lambda_h(nzb_wall,m)     = building_pars(ind_tc1_wall_r,st)
+                 surf_usm_h(l)%lambda_h(nzb_wall+1,m)   = building_pars(ind_tc1_wall_r,st)
+                 surf_usm_h(l)%lambda_h(nzb_wall+2,m)   = building_pars(ind_tc2_wall_r,st)
+                 surf_usm_h(l)%lambda_h(nzb_wall+3,m)   = building_pars(ind_tc3_wall_r,st)
+
+                 surf_usm_h(l)%rho_c_green(nzb_wall,m)      = rho_c_soil !building_pars(ind_hc1_wall_r,st)
+                 surf_usm_h(l)%rho_c_green(nzb_wall+1,m)    = rho_c_soil !building_pars(ind_hc1_wall_r,st)
+                 surf_usm_h(l)%rho_c_green(nzb_wall+2,m)    = rho_c_soil !building_pars(ind_hc2_wall_r,st)
+                 surf_usm_h(l)%rho_c_green(nzb_wall+3,m)    = rho_c_soil !building_pars(ind_hc3_wall_r,st)
+                 surf_usm_h(l)%lambda_h_green(nzb_wall,m)   = lambda_h_green_sm !building_pars(ind_tc1_wall_r,st)
+                 surf_usm_h(l)%lambda_h_green(nzb_wall+1,m) = lambda_h_green_sm !building_pars(ind_tc1_wall_r,st)
+                 surf_usm_h(l)%lambda_h_green(nzb_wall+2,m) = lambda_h_green_sm !building_pars(ind_tc2_wall_r,st)
+                 surf_usm_h(l)%lambda_h_green(nzb_wall+3,m) = lambda_h_green_sm !building_pars(ind_tc3_wall_r,st)
+
+                 surf_usm_h(l)%rho_c_window(nzb_wall,m)      = building_pars(ind_hc1_win_r,st)
+                 surf_usm_h(l)%rho_c_window(nzb_wall+1,m)    = building_pars(ind_hc1_win_r,st)
+                 surf_usm_h(l)%rho_c_window(nzb_wall+2,m)    = building_pars(ind_hc2_win_r,st)
+                 surf_usm_h(l)%rho_c_window(nzb_wall+3,m)    = building_pars(ind_hc3_win_r,st)
+                 surf_usm_h(l)%lambda_h_window(nzb_wall,m)   = building_pars(ind_tc1_win_r,st)
+                 surf_usm_h(l)%lambda_h_window(nzb_wall+1,m) = building_pars(ind_tc1_win_r,st)
+                 surf_usm_h(l)%lambda_h_window(nzb_wall+2,m) = building_pars(ind_tc2_win_r,st)
+                 surf_usm_h(l)%lambda_h_window(nzb_wall+3,m) = building_pars(ind_tc3_win_r,st)
+
+                 surf_usm_h(l)%target_temp_summer(m)  = building_pars(ind_indoor_target_temp_summer,st)
+                 surf_usm_h(l)%target_temp_winter(m)  = building_pars(ind_indoor_target_temp_winter,st)
+!
+!--              Emissivity of wall-, green- and window fraction
+                 surf_usm_h(l)%emissivity(m,ind_veg_wall)  = building_pars(ind_emis_wall_r,st)
+                 surf_usm_h(l)%emissivity(m,ind_pav_green) = building_pars(ind_emis_green_r,st)
+                 surf_usm_h(l)%emissivity(m,ind_wat_win)   = building_pars(ind_emis_win_r,st)
+
+                 surf_usm_h(l)%transmissivity(m)      = building_pars(ind_trans_r,st)
+
+                 surf_usm_h(l)%z0(m)                  = building_pars(ind_z0,st)
+                 surf_usm_h(l)%z0h(m)                 = building_pars(ind_z0qh,st)
+                 surf_usm_h(l)%z0q(m)                 = building_pars(ind_z0qh,st)
+!
+!--              Albedo type for wall fraction, green fraction, window fraction
+                 surf_usm_h(l)%albedo_type(m,ind_veg_wall)  = INT( building_pars(ind_alb_wall_r,st) )
+                 surf_usm_h(l)%albedo_type(m,ind_pav_green) = INT( building_pars(ind_alb_green_r,st) )
+                 surf_usm_h(l)%albedo_type(m,ind_wat_win)   = INT( building_pars(ind_alb_win_r,st) )
+
+                 surf_usm_h(l)%zw(nzb_wall,m)   = building_pars(ind_thick_1_wall_r,st)
+                 surf_usm_h(l)%zw(nzb_wall+1,m) = building_pars(ind_thick_2_wall_r,st)
+                 surf_usm_h(l)%zw(nzb_wall+2,m) = building_pars(ind_thick_3_wall_r,st)
+                 surf_usm_h(l)%zw(nzb_wall+3,m) = building_pars(ind_thick_4_wall_r,st)
+
+                 surf_usm_h(l)%zw_green(nzb_wall,m)   = building_pars(ind_thick_1_wall_r,st)
+                 surf_usm_h(l)%zw_green(nzb_wall+1,m) = building_pars(ind_thick_2_wall_r,st)
+                 surf_usm_h(l)%zw_green(nzb_wall+2,m) = building_pars(ind_thick_3_wall_r,st)
+                 surf_usm_h(l)%zw_green(nzb_wall+3,m) = building_pars(ind_thick_4_wall_r,st)
+
+                 surf_usm_h(l)%zw_window(nzb_wall,m)   = building_pars(ind_thick_1_win_r,st)
+                 surf_usm_h(l)%zw_window(nzb_wall+1,m) = building_pars(ind_thick_2_win_r,st)
+                 surf_usm_h(l)%zw_window(nzb_wall+2,m) = building_pars(ind_thick_3_win_r,st)
+                 surf_usm_h(l)%zw_window(nzb_wall+3,m) = building_pars(ind_thick_4_win_r,st)
+
+                 surf_usm_h(l)%green_type_roof(m) = building_pars(ind_green_type_roof,st)
+
+              ENDIF
+           ENDDO
         ENDDO
 
